static char *cvs_id =" $Id: xnd_use.c,v 1.2 2002/01/10 15:24:45 berar Exp $ ";
/* XND_USE.C */
#define USE_ATOM
#include "../xnd_def.h"
#ifdef __BORLANDC__
#include <alloc.h>
#endif
#include <string.h>

/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
/* verbose_printf, tst_abort et chk_abort utilisent ou stdarg.h ou varargs.h si KK */
#ifndef NO_PROTO
#include <stdarg.h>
void tst_abort (int test, char *format, ... )
{   char msg[80];
    va_list argptr;
    if (test)
    {    va_start (argptr, format);
	 vsprintf (msg,format, argptr);
	 va_end (argptr);
	 termine(10, msg);
    }   }
void chk_abort (char *format, ... )
{   char msg[80];
    va_list argptr;

    va_start (argptr, format);
    vsprintf (msg,format, argptr);
    va_end (argptr);
    termine(16, msg);
    }
int verbose_printf (char *format, ... )
{   char msg[250];
    int i;
    va_list argptr;
    va_start (argptr, format);
    vsprintf (msg,format, argptr);
    va_end (argptr);
    if (bavard) printf("%s", msg); 
    i = fprintf(list_fich,"%s", msg);
    fflush(list_fich);
    return i;
    }
#else
/*  les memes avec varargs............... */
#include <varargs.h>
void tst_abort (va_alist)
va_dcl
{   va_list args;
    int test;
    char *format;
    char msg[80];
    va_start (args);
    test = va_arg(args, int);
    if (test)
    {    format = va_arg(args, char *);
	 vsprintf (msg,format, args);
	 va_end (args);
	 termine(10, msg);
    }   }
void chk_abort (va_alist)
va_dcl
{   va_list args;
    char *format;
    char msg[80];
    va_start (args);
    format = va_arg(args, char *);
    vsprintf (msg,format, args);
    va_end (args);
    termine(16, msg);
    }
int verbose_printf (va_alist)
va_dcl
{   va_list args;
    char *format;
    char msg[250];
    va_start (args);
    format = va_arg(args, char *);
    vsprintf (msg,format, args);
    va_end (args);
    if (bavard) printf("%s", msg); 
    if (list_fich )return fprintf(list_fich,"%s", msg);
    return -1;
    }
#endif
/* ------------------------------------------------------- */
void *tst_alloc (P_(int) nb, P_(int) size, P_(char *) name)
#ifdef NO_PROTO
int nb;
int size;
char *name;
#endif
{  void  *ptr;
   char msg[80];
   if (size * (long) nb > MAX_ALLOC)
   {  sprintf (msg," Alloc %d * %d %s > %ld",nb,size,name,MAX_ALLOC);
	   termine (14,msg);
	   }
   push_err_msg("tst_alloc(xnd_use.c)");
   if (nb && size) ptr = (void *) calloc (nb, size); else ptr = NULL;
   if (ptr==NULL && nb!=0)
	{  sprintf (msg,E_ALLOC,nb,size,name);
	   while (ptr == NULL)
	   {	nb = (nb * 3) / 4;
		   ptr = (void *) calloc (nb,size);
		   if (ptr != NULL)
		   {  fprintf(list_fich," Memoire restante disponible pour %u elements de dimension %u\n",nb, size);
			   termine (14, msg);
			   }
		   if (nb <= 2)
		   { 	fprintf (list_fich," Aucune memoire disponible\n");
			   termine (14, msg);
			   }
	      }	}
   pop_err_msg();
   return ptr;
   }
/* ------------------------------------------------------- */
char *str_alloc (P_(char *) content)
#ifdef NO_PROTO
char *content;
#endif
{  int l;
   char * ptr = NULL; 
   push_err_msg("str_alloc(xnd_use.c)");
	if ( content ) 
	{  l = 1 + strlen(content);
      ptr = (char *) malloc (l); 
		}
   tst_abort( (ptr==NULL), "str_alloc");
	strcpy( ptr, content);
   pop_err_msg();
   return ptr;
   }
/* ------------------------------------------------------------------ */
FILE *tst_open (P_(char *) name, P_(char *) mode, P_(char *) msg)
#ifdef NO_PROTO
char *name;
char *mode;
char *msg;
#endif
{   FILE *file;
    char nmsg[100];
    file = fopen (name, mode);
    if (file==NULL)
    {    sprintf (nmsg,E_FOPEN,name,msg);
	 termine(10, nmsg);
	 }
    return(file);
    }

/* ================================================================ */

