/* $Id: xnd_t_phase.h,v 1.2 2002/05/02 12:43:28 berar Exp $ */
/* xnd_t_phase.h     header for phase structure   */
/* --------------------------------------------- */
#ifndef  XND_T_PHASE_H_INCLUDED  /* included once only */
#define  XND_T_PHASE_H_INCLUDED
/* ---------------------------------------------- */
/* following lines concern more crystal than phases */ 
/* ---------------------------------------------- */
typedef struct
{     char      nom[NAME_LG];
      int       n_atom;   /* independant */
      int       n_orien;
      int       nt_orien; /* n_orien * n_manip */
      int       n_prof;
      int       m_prof;   /* zero==common else by sets */
      int       nb_par;   /* atomiques possibles        */
      int       nature;
      int       nb_bloc;
      int       nb_atom;   /* en tout */
      int       nb_bond;   /* temps contrainte , nb pas distrib amorphe*/
      int       uncoherent; /* diffus ( thermique ... */
      int       nb_tds;
      int       nb_dist;   /* distance ou distrib radiale */
      int       nb_angl;
		int       nb_sets;   /* sets with generating rules */
      int       hkl_size;
      int       num;       /*  */
      int       n_var;
		int       *c_prof;   /*numero des fonctions utilisees */
      int       *c_orien;
      sint      remark;
      sint      remark_orien;
      sint      remark_prof;
      sint      remark_bond;
      float     temp_orig;
      SYMGRP_PTR  symgrp;
      ATOM_PTR  atom;
/*      HKL_PTR   hkl_tds;  /* ?????? */
      VAR_PTR   ech;      /* table de 2 */
      VAR_PTR   transit;  /* table de 3 */
      VAR_PTR   cell;     /* table de 6 */
      VAR_PTR   prof;     /* table de 4*n_prof */
      VAR_PTR   asym;    /* table max_asym*n_asym*PASYM */
      VAR_PTR   orien;    /* table de n_orien   */
      VAR_PTR   vector;   /* used only for incommensurate, else .size=0 */
      VAR_PTR   tds;
      VAR_PTR   radial;
      float     *bond;     /* temps contrainte */
      PENAL_PTR  dist;
      PENAL_PTR  angl;
      VAR_PTR   bloc;
      int       *bl_atom;
      ATOM_PTR  *bl_ortho;
      ATOM_PTR  *bl_relat;
      MODUL_PTR  magnet;
      MODUL_PTR  modul;
		SETS_PTR  sets;
      }   TYPE_PHASE;
/* --------------------------------------------- */
extern TYPE_PHASE  *phase;
extern TYPE_PHASE  *l_phase;
/* --------------------------------------------- */
/* --------------------------------------------- */
#endif          /*  XND_T_PHASE_H_INCLUDED       */
/* --------------------------------------------- */
