/* $Id: xnd_t_sym.h,v 1.1.1.1 1999/11/22 18:45:00 berar Exp $ */
/* xnd_t_sym.h    header for sym usage           */
/* --------------------------------------------- */
#ifndef  XND_T_SYM_H_INCLUDED  /* included once only */
#define  XND_T_SYM_H_INCLUDED
/* --------------------------------------------- */
/* --------------------------------------------- */
typedef struct
{     char    nom[SYM_ID];
      char    comment[NAME_LG];
      char    systeme;
      char    holoedre;   /* dimension pour module */
      char    bravais;
      char    centro;
      char    nops;
      char    size;       /*  12 normalement sauf modulation */
      float   coef[1];    /* (xx, xy, xz, tx, yx......zz, tz ) * nops */
      }     TYPE_SYMGRP;

typedef struct
{      float    matr[6];
       float    vect[3];
       }    TYPE_SYMOP;
/* --------------------------------------------- */
extern TYPE_SYMGRP * current_symgrp;
/* --------------------------------------------- */
/* defined in XND_RSYM.C                         */
/* --------------------------------------------- */
void num_deno       PROTO((float fract, int *num, int *deno));
int analyse_xyz_pos PROTO((char *ligne, float * l_coef, TYPE_SYMGRP * l_sym, int dim));
TYPE_SYMGRP * get_sym     PROTO((char *modele));
TYPE_SYMGRP * read_sym    PROTO((FILE *file));
void print_sym      PROTO((TYPE_SYMGRP * symgrp, int cas));
void new_sym        PROTO((TYPE_SYMGRP * symgrp));
/* --------------------------------------------- */
/* defined in XND_SYM.C                          */
/* --------------------------------------------- */
int    ini_3D_fhkl_mult    PROTO((TYPE_SYMGRP *s ));
void * ini_3D_extinction   PROTO((TYPE_SYMGRP *s ));
void * ini_3D_multiplicity PROTO((TYPE_SYMGRP *s ));
void * ini_3D_gen_holoedre PROTO((TYPE_SYMGRP *s ));
/* --------------------------------------------- */
#endif          /*  XND_T_SYM_H_INCLUDED        */
/* --------------------------------------------- */

 
