static char *cvs_id =" $Id: xnd_sng.c,v 1.1.1.1 1999/11/21 08:51:00 berar Exp $ ";
/* XND_SGN  single crystal or hkl files ... */

#define USE_RPRO
#define  USE_BRAGG
#define USE_VAR
#define USE_SYM
#define USE_MODUL
#define USE_SCAN
#define USE_EXPER
#define USE_HKLOBS
#define USE_ATOM
#define USE_PHASE
#define USE_PSEUDO
#include "xnd_def.h"
#include "xnd_cah.h"
#include "xnd_snh.h"

#include <string.h>

/* ----------------------------------------------------------- */
static int    sng_dim;
static int   *sng_pos;
static float *sng_dfdx;
/* ----------------------------------------------------------- */
void sgn_traite_hkl(P_(void))
{   int i, j;
    int pos=0;
    TYPE_HKLOBS hkl_obs;
    float d; 
    push_err_msg("sgn_traite_hkl");
    if (fread ( &hkl_obs, sizeof(TYPE_HKLOBS), 1, hkldata_fich) != 1) termine (15,E_RDATF);
    temp = &temp_phase;
    for (j=0; j<3+current_modul->size; j++)  act->h[j] = hkl_obs.h[j];
    (*hkl_eff)();
    q = h_eff * ( h_eff * g_aa + k_eff * g_ab + l_eff * g_ac);
    q += k_eff * ( k_eff * g_bb + l_eff * g_bc ) + l_eff * l_eff * g_cc;
    s=sqrt(q);
    act->dist = 1/s;
    F_A = F_B = act->f_abm[0] = act->f_abm[1] = 0;
    for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
       pos +=  (*fhkl_eff) (pos);
    for (j=0;j<l_phase->nb_bloc;j++)
       for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
          pos += (*fhkl_eff) (pos);
    if (dif_nature && EXPER_RXA) 
    {     F_A += act->f_abm[0];
          F_B += act->f_abm[1];
          }
    fhkl_2 = sqrt(F_A * F_A + F_B * F_B);
    d = hkl_obs.f_obs - fhkl_2 * echelle;
    l_indic->sd_wp += d * d * hkl_obs.weight;
    l_indic->so_wp += hkl_obs.f_obs * hkl_obs.f_obs * hkl_obs.weight;
    l_indic->sd_p += fabs(d);
    l_indic->so_p += hkl_obs.f_obs;
    if (fini==0 && minli==0)
    {	int ii, jj, pos=0;
        float v, z;
	for (i=0;i<sng_dim;i++) sng_dfdx[i]=0;
	for (i=0;i<sng_dim;i++) sng_pos[i]=0;
        /* le facteur d'echelle */
	temp = &temp_exper;
        var_init(l_onde);
	VAR_io_id 
	if ((j=var_param(1))!=0) 
	{    sng_pos[pos]=j;
	     sng_dfdx[pos++]=fhkl_2;
	     }
        /* atomic parameters */
	if (deriv_atom)
	{   int dxpos = 0;
	     for (ii=0,l_atom=l_phase->atom; ii<l_phase->n_atom;ii++,l_atom++)
	     {   var_init(l_atom->x);
		 VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0 && fhkl_2 != 0)
		  {    sng_pos[pos]=j;
	               z = F_A * fab_deriv[0][dxpos+i];
		       if (!centro) z += F_B * fab_deriv[1][dxpos+i];
		       sng_dfdx[pos++] = z * var_derive() /fhkl_2;
 		       }
		  dxpos+=l_atom->nb;
		  if (l_atom->n_modul) 
		  {   var_init(l_atom->modul);
		      VAR_io_id  for (i=0;i<l_atom->n_modul*AMODUL;i++)
		      if ((j=var_param(i))!=0 && fhkl_2 != 0)
		      {    sng_pos[pos]=j;
	                   z = F_A * fab_deriv[0][dxpos+i];
		           if (!centro) z += F_B * fab_deriv[1][dxpos+i];
		           sng_dfdx[pos++] = z * var_derive() /fhkl_2;
                           }
		      dxpos+=l_atom->n_modul*AMODUL;
		      }       
		  if (l_atom->n_anharm) 
		  {   var_init(l_atom->anharm);
		      VAR_io_id  for (i=0;i<l_atom->n_anharm;i++)
		      if ((j=var_param(i))!=0 && fhkl_2 != 0)
		      {    sng_pos[pos]=j;
	                   z = F_A * fab_deriv[0][dxpos+i];
		           if (!centro) z += F_B * fab_deriv[1][dxpos+i];
		           sng_dfdx[pos++] = z * var_derive() /fhkl_2;
                           }
		      dxpos+=l_atom->n_anharm;
		      }       
		  }
             /* blocs rigides exprimes ici dans les coordonnees atomiques relatives */
	     for (jj=0; jj<l_phase->nb_bloc;jj++)
	     for (ii=0,l_atom=l_phase->bl_relat[jj]; ii<l_phase->bl_atom[jj];
		     ii++,dxpos+=l_atom->nb,l_atom++)
	     {   var_init(l_atom->x);
		 VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0)
		  {   sng_pos[pos]=j;
	              z = F_A * fab_deriv[0][dxpos+i];
		      if (!centro) z += F_B * fab_deriv[1][dxpos+i];
		      sng_dfdx[pos++] = z * var_derive() /fhkl_2;
		  }   }
	      } /* if deriv_atom */
	 /* sum the derivatives associated with the same parameter */     
	 for (i=0;i<sng_dim;i++)
	 {  ii = sng_pos[i];
	    for (j=i+1;j<sng_dim;j++) 
	    {   jj = sng_pos[j];
	        if ( sng_dfdx[i] != 0 && jj == ii)
		{   sng_dfdx[i] += sng_dfdx[j];
		    sng_pos[j] = 0;
		    }
		}
            }
         /*now add to the general least-square matrix */
	 for (i=0;i<sng_dim;i++) if (sng_pos[i])
	 {  ii = sng_pos[i]-1;
	    v =  hkl_obs.weight * sng_dfdx[i];
	    y_vect[ii] += v * d;
	    for (j=0;j<=i;j++)  if (sng_pos[j])
	    {   jj = sng_pos[j]-1;
	        if ( jj <= ii) matrice[(ii*(ii+1))/2+jj] += v * sng_dfdx[j];
	         else matrice[(jj*(jj+1))/2+ii] += v * sng_dfdx[j];
	        }
	    }
	 }
    
    if (fini && prt_hkl) 
    {   fprintf (hkl_fich,"%4d %3d %3d %3d", m_bragg,  H, K, L);
        for (i=0;i<prt_modsize;i++) fprintf (hkl_fich," %3d", hkl_obs.h[3+i]);
        fprintf (hkl_fich,"    %7.1f  %7.1f ( %7.1f  %7.1f )\n",
           hkl_obs.f_obs/echelle, fhkl_2,  F_A, F_B);
        }
    pop_err_msg();
    }

/* ----------------------------------------------------------- */
/* ----------------------------------------------------------- */
int sng_crystal(P_(float *) t_sng)
#ifdef NO_PROTO
float *t_sng;
#endif
{   int i, j, ic, iphase;
    push_err_msg("sng_crystal(xnd_sng.c)");
    if (minli==0 && (n_exper>1 || nt_diag>1)) verbose_printf 
         ("\n EXPERIMENT '%s' at %.3f\n", l_exper->nom, l_diag->temp);

    for (act->phase=iphase=0,l_pseudo_phase=pseudo_phase;
            iphase<tot_phase; iphase++,act->phase++,l_pseudo_phase++)
    {   if ( l_pseudo_phase->reference != l_exper->n_lambda) continue;
        if ( l_pseudo_phase->ps_case == PS_DUMMY) continue;
        l_phase = l_pseudo_phase->phase;
        push_err_msg(l_phase->nom);
        temp_phase = l_diag->temp-l_phase->temp_orig;
        temp = &temp_phase;
        
        if (minli==0 )   fprintf (list_fich," PHASE #%d : '%s' %s\n", act->phase, 
                     l_phase->nom, l_pseudo_phase->txt);
           
     current_symgrp = l_phase->symgrp;
     if (current_symgrp != NULL)
     {    systeme = current_symgrp->systeme;
          centro  = current_symgrp->centro;
          dim_centro = centro ? 1 : 2;
	  }
     current_satel = l_pseudo_phase->satel;
     current_modul = l_pseudo_phase->modul;
     fhkl_eff = l_pseudo_phase->fhkl_eff;
     hkl_eff    = l_pseudo_phase->hkl_eff;
     ini_metric();
     
     if ((minli==0 && fini==0) && l_phase->nb_par)
     {   deriv_atom=l_phase->nb_par;
         for (ic=0;ic<dim_centro;ic++) 
	 {   fab_deriv[ic] = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
             if (dif_nature==EXPER_RXA)
             fabm_deriv[ic] = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
             }
          }
    else deriv_atom = 0;
    sng_dim = 0;
    var_init(l_onde);
    VAR_io_id if (var_param(1)!=0) sng_dim++;
    if (deriv_atom)
	{   int ii, jj;
	    for (ii=0,l_atom=l_phase->atom; ii<l_phase->n_atom;ii++,l_atom++)
	     {   var_init(l_atom->x);
		 VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0) sng_dim++;
		 if (l_atom->n_modul)
		 {   var_init(l_atom->modul);
		      VAR_io_id  for (i=0;i<l_atom->n_modul*AMODUL;i++)
		      if ((j=var_param(i))!=0) sng_dim++;
		      }
		  if (l_atom->n_anharm)
		  {   var_init(l_atom->anharm);
		      VAR_io_id  for (i=0;i<l_atom->n_anharm;i++)
		      if ((j=var_param(i))!=0) sng_dim++;
		      }
		  }
	     for (jj=0; jj<l_phase->nb_bloc;jj++)
	     for (ii=0,l_atom=l_phase->bl_relat[jj]; ii<l_phase->bl_atom[jj];
		     ii++,l_atom++)
	     {   var_init(l_atom->x);
		 VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0) sng_dim++;
                 }
	      }
    if (sng_dim)
    {   sng_pos =  (int *) tst_alloc (sng_dim, sizeof(int),"deriv");
        sng_dfdx = (float *) tst_alloc (sng_dim, sizeof(float),"deriv");
        }

    if (fini && prt_hkl)
    {   fprintf (hkl_fich,"#%s a %f\n#      h   k   l", l_exper->nom,l_diag->temp);
        for (i=0;i<prt_modsize;i++) fprintf (hkl_fich,"  m%d", i+1);
        fprintf (hkl_fich,"      f_obs   f_calc (    f_a       f_b )\n");
        }

     act->lambda=l_exper->n_lambda;
     temp = &temp_exper;
     var_init (l_onde);
     lambda = var_valeur (0);
     echelle = var_valeur (1);
     if (dif_nature == EXPER_RXA) ini_anodif();

     temp = &temp_phase;
     for  (m_bragg=0; m_bragg<l_diag->n_points; m_bragg++) sgn_traite_hkl();

    if (minli==0)
    {   l_indic->s_n = m_bragg;
        printf("  RwF=%.4f             RF=%.4f         n=%d\n", 
           sqrt(l_indic->sd_wp/l_indic->so_wp), l_indic->sd_p/l_indic->so_p, l_indic->s_n);
        fprintf(list_fich, "  RwF=%.4f             RF=%.4f         n=%d\n\n", 
           sqrt(l_indic->sd_wp/l_indic->so_wp), l_indic->sd_p/l_indic->so_p, l_indic->s_n);
        }   
     if (deriv_atom)
     {   for (ic=0;ic<dim_centro;ic++) 
	 {   free (fab_deriv[ic]);
             if (dif_nature==EXPER_RXA) free (fabm_deriv[ic]);
         }   }
    if (sng_dim)
    {   free (sng_pos);
        free (sng_dfdx);
         }
       if (l_phase->nb_bloc) free_blk();
       pop_err_msg();
       }   /* phase */
    pop_err_msg();
    *t_sng += l_indic->sd_wp;
    return m_bragg;
    }

/* ----------------------------------------------------------- */
